Package org.apache.qpid.proton.codec

# Class AbstractDescribedType<T,M>

java.lang.Object
org.apache.qpid.proton.codec.AbstractDescribedType<T,M>

All Implemented Interfaces:
  `AMQPType<T>`

Direct Known Subclasses:
  `AcceptedType`, `AmqpSequenceType`, `AmqpValueType`, `ApplicationPropertiesType`, `AttachType`, `BeginType`, `CloseType`, `CoordinatorType`, `DataType`, `DeclaredType`, `DeclareType`, `DeleteOnCloseType`, `DeleteOnNoLinksOrMessagesType`, `DeleteOnNoLinksType`, `DeleteOnNoMessagesType`, `DeliveryAnnotationsType`, `DetachType`, `DischargeType`, `DispositionType`, `EndType`, `ErrorConditionType`, `FlowType`, `FooterType`, `HeaderType`, `MessageAnnotationsType`, `ModifiedType`, `OpenType`, `PropertiesType`, `ReceivedType`, `RejectedType`, `ReleasedType`, `SaslChallengeType`, `SaslInitType`, `SaslMechanismsType`, `SaslOutcomeType`, `SaslResponseType`, `SourceType`, `TargetType`, `TransactionalStateType`, `TransferType`

public abstract class AbstractDescribedType<T,M> extends Object implements AMQPType<T>

## Constructor Summary

Constructors
Constructor
Description
`AbstractDescribedType(EncoderImpl encoder)`

## Method Summary

Modifier and Type
Method
Description
`Collection<TypeEncoding<T>>`
`getAllEncodings()`
`TypeEncoding<T>`
`getCanonicalEncoding()`
`DecoderImpl`
`getDecoder()`
`protected abstract UnsignedLong`
`getDescriptor()`
`EncoderImpl`
`getEncoder()`
`TypeEncoding<T>`
`getEncoding(T val)`
`protected abstract M`
`wrap(T val)`
`void`
`write(T val)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.apache.qpid.proton.codec.AMQPType

`getTypeClass`

## Constructor Details

### AbstractDescribedType

public AbstractDescribedType(EncoderImpl encoder)

## Method Details

### getDescriptor

protected abstract UnsignedLong getDescriptor()

### getEncoder

public EncoderImpl getEncoder()

### getDecoder

public DecoderImpl getDecoder()

### getEncoding

public TypeEncoding<T> getEncoding(T val)

Specified by:
  `getEncoding` in interface `AMQPType<T>`

### wrap

protected abstract M wrap(T val)

### getCanonicalEncoding

public TypeEncoding<T> getCanonicalEncoding()

Specified by:
  `getCanonicalEncoding` in interface `AMQPType<T>`

### getAllEncodings

public Collection<TypeEncoding<T>> getAllEncodings()

Specified by:
  `getAllEncodings` in interface `AMQPType<T>`

### write

public void write(T val)

Specified by:
  `write` in interface `AMQPType<T>`